//cacluate the similarity matrix for retrieved docments for clustering
//implement clustering

import java.io.*;
import java.util.*;
//import au.com.pharos.gdbm.GdbmFile;
//import au.com.pharos.gdbm.GdbmException;
//import au.com.pharos.packing.StringPacking;

class Node {
	public String text;
	public String title;
	public String url;
	public int height;
	public int docid;
	public int flag;
	public int level;
	public int count;
	Node left;
	Node right;
	Node parent;
	Node(){
		text = "";
		title= "";
		url="";
		height = 0;
		docid=999999999;
		left = null;
		right = null;
		parent = null;
		flag=0;
		level=0;
		count=1;
	}
	Node(Node node){
		text = node.text;
		title=node.title;
		url=node.url;
		height = node.height;
		left = node.left;
		right = node.right;
		parent = node.parent;
		docid=node.docid;
		flag=node.flag;
		level=node.level;
		count=node.count;
	}
	public Node getLeft() {
		return left;
	}
	public Node getRight() {
		return right;
	}
	public Node getParent() {
		return parent;
	}

	public void addRight(Node node) {
		right = node;
	}

	public void addLeft (Node node) {
		left = node;
	}
	public void addParent (Node node) {
		parent= node;
	}




	/*public void updateHeight(Node root){
		Node temp = new Node();
		Vector v = new Vector();
		v.add(root);
		while (v.size() > 0){
			temp = (Node) v.remove(0);
			if (temp.left != null){
				temp.left.height = temp.height - 1;
				v.add(temp.left);
				}
			if (temp.right != null){
				temp.right.height = temp.height - 1;
				v.add(temp.right);
				}
			}
    }*/



}

public class Clustering
 {
    //public TreeMap clusterTreeMap;
    public Vector clusterVector,resultVector,simVector;
    public Search search;
	private String strTreeMenuHtml;
	private int intLevel=0;

	public Clustering () {
		try {
		    search=new Search();
		}
		catch (Exception e) {
			System.out.println("Error Clustering "+e.getMessage());
		}

    }
    public void setSearchResult(Vector r){
		try {
			int intTotal=20;
			int intSize=r.size();
			if (intSize<=intTotal) {
		        resultVector=(Vector)r.clone();
		    }
		    else {
		    	resultVector=new Vector();
		    	for (int i=0;i<intTotal;i++) {
		    	    resultVector.add((Integer)r.elementAt(i));
		    	}
		    }
		}
		catch (Exception e) {
			System.out.println("Error setSearchResult "+e.getMessage());

		}
    }
    public int getIndex(int i, int j){
    	if (j>i){
    		int k=j;
    		j=i;
    		i=k;
    	}
    	return i*(i-1)/2+j;
    }
    public String getLabelTitle(Node left,Node right) {
    	HashSet leftHashSet=new HashSet();
    	HashSet rightHashSet=new HashSet();
    	String strTitle="";
    	String strToken="";
        StringTokenizer st = new StringTokenizer(left.title);
        while (st.hasMoreTokens()) {
          	strToken=st.nextToken();
          	leftHashSet.add(strToken);
        }
        
        st = new StringTokenizer(right.title);
        while (st.hasMoreTokens()) {
          	strToken=st.nextToken();
          	rightHashSet.add(strToken);
        }
        
        leftHashSet.retainAll(rightHashSet);
        Iterator iter = leftHashSet.iterator();
        while (iter.hasNext())
            strTitle+=(String)iter.next()+" ";
       
        if (strTitle.compareTo("")==0)
        	strTitle="Level ";
    	return strTitle; //left.title+right.title;
    }
    
    public double getSimMatrix(int i, int j) {
    	if (i==j)
    	    return 0.0;
        return ((Double)simVector.elementAt(getIndex(i,j))).doubleValue();

    }

    public void setSimMatrix(int i, int j,double dblSimilarity) {
    	if (i==j)
    	    return;
        simVector.setElementAt(new Double(dblSimilarity),getIndex(i,j) );
    }

    public void initializeClusters() {
    	try {
    	    int intSize=resultVector.size();
       	    simVector=new Vector();
       	    clusterVector=new Vector();
       	    double dblMax=0.0, dblSimilarity;
       	    int intRow=0,intCol=0;
       	    for (int i=0;i<intSize;i++) {
       	    	Node node=new Node();
       	    	node.docid=((Integer)resultVector.elementAt(i)).intValue();
       	    	node.text="D"+Integer.toString(node.docid);
                node.title=search.replaceString((search.getTitle(node.docid)).trim(),"'"," ");
                node.url="http://www.cs.dal.ca:8074/servlet/DetailServlet?id="+node.docid;
       	    	node.flag=0; //document flag
       	    	node.count=1; //total number of documents under this node
       	    	clusterVector.add (node);
       	    }
       	    // calculate similarity matix
	        for (int i=1;i<intSize;i++) {
        	    Integer IntDocID=(Integer)resultVector.elementAt(i);
        	    int intDocID=IntDocID.intValue();
        	    for (int j=0;j<i;j++) {
        		    int intDocID2=((Integer)resultVector.elementAt(j)).intValue();
            	    dblSimilarity=search.getDocSimilarity(intDocID, intDocID2);
            	    simVector.add(new Double(dblSimilarity));
            	  //  System.out.println(getIndex(i,j)+" ("+i+", "+j+") ("+intDocID+","+intDocID2+") "+dblSimilarity);
                }
            }

            while (intSize>=2) {
            	Vector simUpdateVector=new Vector();
             	//System.out.println("intSize "+intSize);
             	dblMax=0.0;
            	for (int i=1;i<intSize;i++) {
            		for (int j=0;j<i;j++){
            	//		System.out.println("index "+getIndex(i,j));
            			dblSimilarity=getSimMatrix(i,j);
            	//		System.out.println("ok");
            			if (dblSimilarity>dblMax) {
            				dblMax=dblSimilarity;
            				intRow=i;
            				intCol=j;
            			}
            		}
            	}
                //System.out.println(intRow+" "+intCol+" "+dblMax);
                //update similarity matrix, SLNK
                for (int j=0;j<intSize;j++) {
                	double dblSLNKSimilarity=0.0;
                	if ((j!=intRow)&&(j!=intCol)) {
                	   dblSLNKSimilarity=getSimMatrix(intCol,j);
                	   double dblRowSimilarity=getSimMatrix(intRow,j);
                	  // System.out.println("Compare ("+intCol+", "+j+") "+dblSLNKSimilarity+" ("+intRow+", "+j+") "+dblRowSimilarity);
                	   if (dblSLNKSimilarity<dblRowSimilarity)
                	       dblSLNKSimilarity=dblRowSimilarity;
                	   setSimMatrix(intCol,j,dblSLNKSimilarity);
                    }
                }
                //Merge nodes, compress matrix
                for (int i=1;i<intSize;i++) {
                	for (int j=0;j<i;j++) {
                		if ((i==intRow)||(j==intRow)) {
                		}
                		else {
                			simUpdateVector.add(new Double(getSimMatrix(i,j)));
                			//System.out.println(getSimMatrix(i,j));
                		}
                	}
                }



                //cluster two nodes
                Node node=new Node();
                Node left=(Node)clusterVector.elementAt(intCol);
                Node right=(Node)clusterVector.elementAt(intRow);
                node.title=getLabelTitle(left,right);
                node.url="";
                node.addLeft(left);
                node.addRight(right);
                node.flag=1;//cluster flag
                node.count=node.left.count+node.right.count;
                int intLevel=left.level;
                if (right.level>intLevel)
                    intLevel=right.level;
                intLevel++;
                node.level=intLevel;
                node.text=left.text+"L"+node.level;
                left.parent=node;
                right.parent=right;
                
                clusterVector.setElementAt(node,intCol);

                //put back the new node to clusterVector;
                clusterVector.removeElementAt(intRow);
             	intSize=clusterVector.size();
             	simVector=(Vector)simUpdateVector.clone();


                for (int i=1;i<intSize;i++) {
        	        for (int j=0;j<i;j++) {
            	        dblSimilarity=getSimMatrix(i,j);
            	       // System.out.println(getIndex(i,j)+" ("+i+", "+j+") "+dblSimilarity);
                    }
                }



            }


        }
        catch (Exception e) {
        	System.out.println("Error initializeClusters "+e.getMessage());
        }
    }

    /*public void visitTree (Node node) {
    	try {
    	if ((node.left==null )&&(node.right==null)) {
    		    	node.height=intLevel;
    	System.out.println(node.text);
    	System.out.println(node.height);

    		//System.out.println(node.text);
    	//	System.out.println(intLevel);
    		return;
    	}
    	intLevel++;
    	if (node.left!=null) {
    	    visitTree(node.left);
    	}
    	intLevel--;
    	node.height=intLevel;
    	System.out.println(node.text);
    	System.out.println(node.height);
    	intLevel++;

    	if (node.right!=null) {
    		visitTree(node.right);
    	}


    	intLevel--;

        }
        catch (Exception e) {
        	System.out.println("Error visitTree "+e.getMessage());
        }
    	return; 
    }*/

    public void visitTree (Node node) {

    	if (node.left!=null) {
   	        strTreeMenuHtml+=node.text+".addItem('"+node.left.title+" ("+node.left.count+")','"+node.left.url+"','text', '"+node.left.title+"','menu_link_txt.gif');\n";
            if (node.left.flag==1) {
            	// cluster
                strTreeMenuHtml+="var "+node.left.text+"= null;\n";            	
        	    strTreeMenuHtml+=node.left.text+" = new MTMenu();\n";
        	}
   	        visitTree(node.left);
            if (node.left.flag==1) {
                strTreeMenuHtml+=node.text+".makeLastSubmenu("+node.left.text+", false, 'book-closed.gif','book-open.gif');\n";
        	}

        }


    	if(node.right!=null) {
           	strTreeMenuHtml+=node.text+".addItem('"+node.right.title+"("+node.right.count+")','"+node.right.url+"','text', '"+node.right.title+"','menu_link_txt.gif');\n";
           	if (node.right.flag==1) {
           		// cluster
                strTreeMenuHtml+="var "+node.right.text+"= null;\n";
         	    strTreeMenuHtml+=node.right.text+"= new MTMenu();\n";
         	}
   		    visitTree(node.right);
           	if (node.right.flag==1) {
                strTreeMenuHtml+=node.text+".makeLastSubmenu("+node.right.text+", false, 'book-closed.gif','book-open.gif');\n";
         	}
        }
    	return;
    }


    public String getTreeMenuHtml(Node node) {
    	strTreeMenuHtml="";
        intLevel=0;
    //	visitTree(node);
    Node fnode=new Node();
//    fnode.text="menu";
//    fnode.flag=-1;
    node.text="menu";
   	strTreeMenuHtml+="var menu= null;\n";
    strTreeMenuHtml+="menu = new MTMenu();\n";
    
    visitTree(node);
    	return strTreeMenuHtml;

    }


    public String showTreeMenu() {
    	String strResult="";
        Node node=(Node)clusterVector.firstElement();
        //node.text="menu";
        strResult=getTreeMenuHtml(node);
        //System.out.println(strResult);
        return strResult;

    }

	public static void main(String[] arg){
		try {
	        //Node root = new Node();
	        //Node left = new Node();
	        //root.addLeft(left);
	        Clustering c=new Clustering();
	       // c.search.KeyWord("nissan toyota");
	        c.search.KeyWord("dalhousie computer program school");
	        //c.search.KeyWord("disaster earthquake");
	        c.search.AndSearch();
	        Vector v=c.search.getSearchResult("OR");
	        c.setSearchResult(v);
            c.initializeClusters();

	        String str=c.showTreeMenu();
	       // System.out.println(str);
	     }
	     catch (Exception e) {
	     	System.out.println("Error main "+e.getMessage());
	     }

	}
}
